Leetcode 300 Longest Increasing Subsequence 最长递增子序列

Given an unsorted array of integers, find the length of longest increasing subsequence.

For example,
Given [10, 9, 2, 5, 3, 7, 101, 18],
The longest increasing subsequence is [2, 3, 7, 101], therefore the length is 4. Note that there may be more than one LIS combination, it is only necessary for you to return the length.

Your algorithm should run in O(n2) complexity.

Follow up: Could you improve it to O(n log n) time complexity?
题意很清楚,就是求最长递增子序列,要求复杂度为O(n2)或者更好为O(n log n)。一种解法是转换为最长路径问题,i< j , 且nums[i]< nums[j]则看做是从i,到j有一条路径。然后用动态规划的思想,状态转移方程伪代码如下:(这里的边只可能是从前指向后的,所以可以使用动态规划,而不是递归,亲测递归会超时)

for j=1,2,3....n
    L(j)=1+max(L(i):(i,j)∈E)
return max L(j)

下面是正确解法:


class Solution {
public:
    int n;

    int lengthOfLIS(vector<int>& nums) {
        vector<vector<int>> map(nums.size(), vector<int>(nums.size(),0));
        n = nums.size();
        if (n == 0) {
            return 0;
        }
        int max = 1;
        for (int i = 0; i < nums.size(); i++) {
            for (int j = i; j < nums.size(); j++) {
                if (nums[i] < nums[j]) {
                    map[i][j] = 1;
                }
            }
        }
        vector<int> dp(n,1);
        for (int i = 1; i < nums.size(); i++) {
            int maxpre = 1;
            for (int j = 0; j < i; j++) {
                if (map[j][i] == 1&&dp[j]+1>maxpre) {
                    maxpre = dp[j] + 1;
                }
            }
            dp[i] = maxpre;
            if (dp[i] > max) {
                max = dp[i];
            }
        }
        return max;
    }
};

猜你喜欢

转载自blog.csdn.net/hello_my_coder/article/details/79008340